// Andreas Kirsch 07

#include "stdlib.h"
#include "memory.h"
#include <iostream>

/*struct CoRoutine {
	typedef signed YieldIndex;
	YieldIndex yieldIndex;

	static const signed YIELD_ZEROTH_STATE = -1;

	CoRoutine() : yieldIndex( YIELD_ZEROTH_STATE ) {
	}
};

#define START_COROUTINE switch( yieldIndex ) { case YIELD_ZEROTH_STATE: {
#define END_COROUTINE } yieldIndex = YIELD_ZEROTH_STATE; }

#define YIELD( value ) do { yieldIndex = __COUNTER__; return( value ); case (__COUNTER__ - 1): ; } while( 0 )
#define RETURN( value ) do { yieldIndex = YIELD_ZEROTH_STATE; return( value ); } while( 0 )

struct CoFibo : CoRoutine {
	int a, b, c;

	int operator() () {
		START_COROUTINE
		a = 0;
		b = 1;
		while( 1 ) {
			YIELD( b );

			c = a;
			a = b;
			b += c;
		}
		END_COROUTINE
	}
};*/

/*
struct myCoroutine {
	typedef unsigned YieldIndex;
	YieldIndex yieldIndex;
	myCoroutine() : yieldIndex( 0 ) {
	}

	int a;

	int operator () () {
		switch( yieldIndex ) {
		case 0:
			{
			a = 0;
			while( 1 ) {
				a++;
				YIELD( a );
			}
			} }
	}
};

myCoroutine myCoroutine;

/*struct myCoroutine {
	typedef unsigned YieldIndex;
	YieldIndex yieldIndex;
	myCoroutine() : yieldIndex( 0 ) {
	}

	int a;
		
	int operator () () {
		switch( yieldIndex ) {
		case 0:
			a =	0;
			while( 1 ) {
				a++;
				// YIELD part 
				yieldIndex = 1;
				return a; case 1:
			0==0;
			}
		}
	}
};

myCoroutine myCoroutine;*/

struct A {
   int b;
   int *c;

   A() {
      c = new int;
   }

   ~A() {
      delete c;
   }
};
/*
void test() {
   {
      A testA;
      testA.b = 1024;
      if( testA.b == 1024 ) 
         __asm jmp exit1
      testA.b = -1024;
   }
exit1:
   ;
}*/

// new generator version!
#define COROUTINE( returnType, name, paramList ) class name { \
   size_t yieldOffset; \
   void *stackCopy; \
   size_t stackSize; \
   \
public: \
   name() : stackCopy( 0 ), stackSize( 0 ), yieldOffset( 0 ) { \
   } \
\
   ~name() { \
      /* this is something bad actually - it should always finish but oh well */ \
      if( stackCopy ) { \
         delete stackCopy; \
      } \
   } \
\
   returnType operator() paramList { \
      size_t __yieldExitOffset; \
      __asm { mov __yieldExitOffset, offset yieldExit_##name } \
      returnType __yieldReturnValue; \
      char __frameStart; \
      \
      if( stackCopy ) { \
         /* restore the stack */ \
         memcpy( &__frameStart - stackSize, stackCopy, stackSize ); \
         size_t localYieldOffset = yieldOffset; \
         __asm { jmp localYieldOffset } \
      }

#define CONCAT( a, b ) a ## b
#define LABEL( line ) CONCAT( __label__, line )

#define YIELD( value ) do { \
         char __frameEnd; \
         /* copy the stack frame */ \
         if( stackCopy ) { \
            delete stackCopy; \
         } \
         stackSize = &__frameStart - &__frameEnd; \
         stackCopy = new char[ stackSize ]; \
         memcpy( stackCopy, &__frameEnd, stackSize ); \
         \
         __yieldReturnValue = (value); \
         size_t localYieldOffset; \
         __asm { mov localYieldOffset, offset LABEL( __LINE__ ) } \
         yieldOffset = localYieldOffset; \
         __asm { jmp __yieldExitOffset } \
LABEL( __LINE__ ): \
         ; \
         } while( 0 )

#define RETURN( value ) \
   do {\
      /* remove the stack copy and clean up */ \
      if( stackCopy ) { \
         delete stackCopy; \
         stackCopy = 0; \
         stackSize = 0; \
      } \
      \
      yieldOffset = 0; \
      return (value);\
   } while( 0 )
 
#define ENDCOROUTINE( name ) \
yieldExit_##name: \
      return __yieldReturnValue; \
   } /* function done */ \
}; /* class done */

COROUTINE( int, testCoroutine, () ) {
   std::cout << "Hello World" << std::endl;
   YIELD( 1 );
   std::cout << "Again: I'm back!" << std::endl;
   YIELD( 2 );
   std::cout << "And one last time!" << std::endl;
   RETURN( 3 );
} ENDCOROUTINE( testCoroutine )

COROUTINE( int, fibonnacci, () ) {
   int a = 1, b = 1;

   while( 1 ) {
      YIELD( b );
      int c = a + b;
      a = b;
      b = c;
   }
} ENDCOROUTINE( fibonnacci )

/*
class testCoroutine { 
   size_t yieldOffset; void *stackCopy; size_t stackSize; 
   void copyStack( char &start, char &end ) { if( stackCopy ) { delete stackCopy; } stackSize = &start - &end + 1; stackCopy = new char[ stackSize ]; memcpy( stackCopy, &start, stackSize ); } 
   void freeStackCopy() { if( !stackCopy ) { return; } delete stackCopy; stackCopy = 0; stackSize = 0; yieldOffset = 0; } 
public: 
   testCoroutine() : stackCopy( 0 ), stackSize( 0 ), yieldOffset( 0 ) { } 
   ~testCoroutine() { if( stackCopy ) { delete stackCopy; } } 

   int operator() () { 
      size_t __yieldExitOffset; 
      __asm { mov __yieldExitOffset, offset yieldExit_testCoroutine } 
      int __yieldReturnValue; 
      char __frameStart; 
      if( stackCopy ) { 
         memcpy( &__frameStart, stackCopy, stackSize ); 
         size_t localYieldOffset = yieldOffset; 
         __asm jmp localYieldOffset; 
      } 
      {
         std::cout << "Hello World" << std::endl;
         do { 
            char __frameEnd; 
            __yieldReturnValue = (1); 
            copyStack( __frameStart, __frameEnd ); 
            size_t localYieldOffset; 
            __asm { mov localYieldOffset, offset __label__191 }
            yieldOffset = localYieldOffset; 
            __asm { jmp __yieldExitOffset }
__label__191: 
            ; 
         } while( 0 );
         std::cout << "Again: I'm back!" << std::endl;
         do { 
            char __frameEnd; 
            __yieldReturnValue = (2); 
            copyStack( __frameStart, __frameEnd );
            size_t localYieldOffset; 
            __asm { mov localYieldOffset, offset __label__193 }
            yieldOffset = localYieldOffset; 
            __asm { jmp __yieldExitOffset }
__label__193: 
            ; 
         } while( 0 );
         std::cout << "And one last time!" << std::endl;
         do { 
            freeStackCopy(); 
            return (3); 
         } while( 0 );
   } 
yieldExit_testCoroutine: 
   return __yieldReturnValue; 
   } 
};
*/

/*
void testSwitch() {
   size_t label;
//    __asm push eax
//    __asm mov eax, jumpHere
//    __asm mov label, eax
//    __asm pop eax
   __asm mov label, OFFSET jumpHere

   std::cout << "test1" << std::endl;

   __asm jmp label

   A a;
   a.b = 10;   

jumpHere:
   A b;
   b.b = 100;
}*/

// void testYield() {
//    static size_t jmpOffset = 0;
// 
//    if( jmpOffset ) {
//       __asm jmp jmpOffset;
//    }
// 
//    std::cout << "Hello World" << std::endl;
//    
//    __asm { mov jmpOffset, offset label } label:
//    std::cout << "And again!" << std::endl;
// }

int main(int argc, char* argv[])
{
	/*std::cout << myCoroutine();
	std::cout << myCoroutine();*/
	/*while( 1 ) {
		std::cout << myMonolog();
	}*/
	/*CoFibo coFibo;
	while( 1 ) {
		std::cout << coFibo();
	}
	return 0;*/
   // test();
   //testSwitch();

//    testYield();
//    testYield();

   fibonnacci fibonnacciTest;
   fibonnacci fibonnacciTest2;
   for( int i = 0 ; i < 10 ; i++ ) {
      std::cout << "First: " << fibonnacciTest() << std::endl;
      if( i % 2 == 0 ) {
         std::cout << "Second: " << fibonnacciTest2() << std::endl;
      }
   }

}

